<template>
  <div class="DataSource">
    <b-row class="headerRow">
      <b-col sm="10" class="headerLeftCol">
        <FilesViewHeader
          @clickFileSelect="clickFileSelect"
          :locale="locale"
          :resource="resource"
          :resourceId="resourceId"
          :resourceName="resourceName"
          :progressbarOccupied="progressbarOccupied"
          :canEditResource="canEditResource"
          :isUploading="isUploading"
          :resourceContentSettings="resourceContentSettings"
        />
      </b-col>
      <b-col sm="2" class="headerRightCol">
        <b-input-group>
          <b-form-input
            v-model="filter"
            type="search"
            id="filterInput"
            :placeholder="$t('typeToSearch')"
          ></b-form-input>
        </b-input-group>
      </b-col>
    </b-row>
    <b-row>
      <b-table
        id="resourceViewTable"
        :fields="headers"
        :items="folder"
        :busy="isBusy"
        :locale="$i18n.locale"
        :filter="filter"
        :filter-included-fields="filterFields"
        selectable
        striped
        bordered
        outlined
        hover
        small
        responsive
        head-variant="dark"
        class="adaptTable"
        ref="adaptTable"
        @row-selected="onRowSelected"
        show-empty
        :empty-text="$t('emptyTableText')"
        :empty-filtered-text="$t('emptyFilterText')"
      >
        <div slot="table-busy" class="text-center text-danger my-2">
          <b-spinner class="align-middle"></b-spinner>
          <strong style="margin-left: 1%">{{ $t("loading") }}</strong>
        </div>
        <template v-slot:head(name)="row">
          <b-form-checkbox
            v-model="selectAll"
            @change="allSelect(row)"
          ></b-form-checkbox>
          <span>{{ $t("fileName") }}</span>
        </template>
        <template v-slot:head(lastModified)="row">
          <span>{{ row.label }}</span>
        </template>
        <template v-slot:head()="row">
          <template
            v-if="
              resourceContentSettings.entriesView.columns.always.includes(
                row.field.key
              )
            "
          >
            <span>{{ row.label }}</span>
          </template>
          <template v-else>
            <span class="additionalColumnHeader">{{ row.label }}</span>
            <i class="material-icons" @click="removeColumn(row)">
              {{ "close" }}
            </i>
          </template>
        </template>
        <template v-slot:head(addColumn)>
          <b-dropdown size="sm" right :no-caret="true" id="addColumnDropDown">
            <template v-slot:button-content>
              <i class="material-icons">arrow_drop_down</i>
            </template>
            <b-form-checkbox
              v-for="column in columns"
              v-model="column.active"
              :key="column.value"
              :value="column.value"
              @change="getTableHeaders()"
              @input="getTableHeaders()"
              @click="getTableHeaders()"
              stacked
            >
              {{ column.label }}
            </b-form-checkbox>
          </b-dropdown>
        </template>
        <template v-slot:cell(name)="row">
          <span class="checkFile">
            <b-form-checkbox
              class="tableCheck"
              v-model="row.rowSelected"
              @change="select(row)"
            />
            <i class="material-icons">
              {{ row.item.isFolder ? "folder" : "insert_drive_file" }}
            </i>
          </span>
          <a
            v-if="
              resourceContentSettings !== null &&
              resourceContentSettings.metadataView !== null &&
              resourceContentSettings.metadataView.editableDataUrl !== null &&
              resourceContentSettings.metadataView.editableDataUrl === false
            "
            class="dataSourceItem"
            :href="'#' + row.item.absolutepath"
            @click="openDataSourceObject(row.item)"
            >{{ row.item.name }}</a
          >
          <a v-else>{{ row.item.name }}</a>
          <b-dropdown
            class="dotMenu"
            left
            variant="link"
            toggle-class="text-decoration-none"
            size="sm"
            :no-caret="true"
            :disabled="
              resourceContentSettings !== null &&
              resourceContentSettings.metadataView !== null &&
              resourceContentSettings.metadataView.editableDataUrl !== null &&
              resourceContentSettings.metadataView.editableDataUrl &&
              resource.Archived
            "
          >
            <template v-slot:button-content> ... </template>
            <b-dropdown-item
              v-if="
                resourceContentSettings !== null &&
                resourceContentSettings.metadataView !== null &&
                resourceContentSettings.metadataView.editableDataUrl !== null &&
                resourceContentSettings.metadataView.editableDataUrl === false
              "
              @click="openDataSourceObject(row.item)"
              >{{ $t("metadataManagerBtnDownload") }}</b-dropdown-item
            >
            <b-dropdown-item
              @click="deleteFile(row.item)"
              :disabled="resource.Archived"
              >{{ $t("metadataManagerBtnDelete") }}</b-dropdown-item
            >
          </b-dropdown>
        </template>
        <template v-slot:cell(size)="row">
          {{ renderSize(row.item) }}
        </template>
        <template v-slot:cell(lastModified)="row">
          {{ renderDate(row.item) }}
        </template>
      </b-table>
      <b-row v-if="!isBusy && errorLoadingResource === true">
        <b-col class="center-align" id="error-loading-resource">{{
          $t("errorLoadingResource")
        }}</b-col>
      </b-row>
    </b-row>
  </div>
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import FilesViewHeader from "./FilesViewHeader.vue";
import { BlobApi, TreeApi } from "@coscine/api-client";
import { LanguageUtil, GuidUtil, FileUtil } from "@coscine/app-util";

import { EntryDefinition } from "@/utils/EntryDefinition";

import ResourceContentSettings from "@/global";

import MetadataManagerUtil from "../utils/MetadataManagerUtil";

import { mapState } from "vuex";
import { BTable } from "bootstrap-vue";
import fileSaver from "file-saver";

export default Vue.extend({
  name: "DataSource",
  data() {
    return {
      headers: [],
      isBusy: true,
      selectAll: false,
      downloadTrigger: false,
      currentPage: 1,
      filter: "",
      folderPath: [] as string[],
      itemList: {},
      errorLoadingResource: false,
      selectableFiles: [] as EntryDefinition[],
      columns: [] as Array<unknown>,
      filterFields: [] as string[],
    };
  },
  components: {
    FilesViewHeader,
  },
  props: {
    locale: String,
    resource: Object,
    resourceId: String,
    resourceName: String,
    folder: {
      default() {
        return [];
      },
      type: Array as PropType<EntryDefinition[]>,
    },
    projectId: String,
    userId: String,
    applicationProfile: Array,
    currentFolder: {
      default: "/",
      type: String,
    },
    fileListEdit: {
      default() {
        return [];
      },
      type: Array as PropType<EntryDefinition[]>,
    },
    progressbarOccupied: Number,
    canEditResource: Boolean,
    isUploading: Boolean,
    resourceContentSettings: Object as () => ResourceContentSettings,
  },
  watch: {
    applicationProfile() {
      this.getColumns();
    },
    columns() {
      this.getTableHeaders();
    },
    resourceContentSettings() {
      this.getTableHeaders();
    },
  },
  computed: {
    ...mapState({
      storedColumns: (state) => (state as any).resourcecontentview.columns,
    }),
  },
  created() {
    this.isBusy = true;
    this.$set(this, "resourceId", GuidUtil.getResourceId());
    this.getColumns();
    this.getTableHeaders();
    if (GuidUtil.isValidGuid(this.resourceId)) {
      // Doesn't end with '/' => Probably a file
      let currentFolder = this.currentFolder;
      if (!currentFolder.endsWith("/")) {
        // TODO: Change to open modal
        this.openDataSourceObject({
          isFolder: false,
          name: currentFolder.substring(currentFolder.lastIndexOf("/") + 1),
          path: currentFolder,
          absolutepath: currentFolder,
        });
        currentFolder = currentFolder.substring(
          0,
          currentFolder.lastIndexOf("/") + 1
        );
      }
      if (currentFolder !== "/") {
        let combine = "";
        const folderSplit = currentFolder.split("/");
        for (const folderKey in folderSplit) {
          if (Object.prototype.hasOwnProperty.call(folderSplit, folderKey)) {
            const folder = folderSplit[folderKey];
            if (combine !== "" && folder === "") {
              continue;
            }
            combine += folder + "/";
            this.folderPath.push(combine);
          }
        }
        this.folderPath.pop();
        if (this.folderPath.length > 0) {
          this.$emit("currentFolder", this.folderPath.pop() as string);
        } else {
          this.$emit("currentFolder", "");
        }
      } else {
        this.$emit("currentFolder", "");
      }
      this.openDataSourceObject({
        isFolder: true,
        name: currentFolder.substring(currentFolder.lastIndexOf("/") + 1),
        path: currentFolder,
        absolutepath: currentFolder,
      });
    } else {
      this.errorLoadingResource = true;
      this.isBusy = false;
    }
  },
  methods: {
    saveInLocalStorage() {
      if (this.columns.length > 0) {
        this.$store.commit("resourcecontentview/storeColumns", {
          resourceId: this.resourceId,
          columns: JSON.stringify(this.columns),
        });
      }
    },
    loadFromLocalStorage() {
      let element = null;
      if (
        this.storedColumns !== null &&
        this.storedColumns[this.resourceId] !== undefined
      ) {
        element = this.storedColumns[this.resourceId];
      }
      let json = [] as Array<unknown>;
      if (element !== null) {
        json = JSON.parse(element);
      }
      return json;
    },
    removeColumn(row: any) {
      for (const column of this.columns) {
        if ((column as any).key === row.column) {
          (column as any).active = false;
        }
      }
    },
    async deleteFile(file: EntryDefinition) {
      this.$emit("waitingForResponse", true);
      await BlobApi.blobDeleteFileWithParameter(
        this.resourceId,
        file.absolutepath
      );
      this.$emit("waitingForResponse", false);
      location.reload();
    },
    getTableHeaders() {
      const headers = [
        {
          label: this.$t("fileName"),
          key: "name",
          sortable: true,
        },
        {
          label: this.$t("lastModified"),
          key: "lastModified",
          sortable: true,
        },
      ];
      const filterFields = headers.map((header) => header.key);
      for (const column of this.resourceContentSettings.entriesView.columns
        .always) {
        if (!filterFields.includes(column)) {
          headers.push({
            label: this.$t(column),
            key: column,
            sortable: true,
          });
          filterFields.push(column);
        }
      }
      for (const columnData of this.columns) {
        if ((columnData as any).active === true) {
          headers.push({
            label: (columnData as any).label,
            key: (columnData as any).key,
            sortable: (columnData as any).sortable,
          });
          filterFields.push((columnData as any).key);
        }
      }
      headers.push({
        label: "add",
        key: "addColumn",
        sortable: false,
      });
      this.$set(this, "filterFields", filterFields);
      this.$set(this, "headers", headers);
      this.saveInLocalStorage();
    },
    getColumns() {
      const tmpColumns = [];
      // keys a, b, name, active
      if (this.applicationProfile.length > 0) {
        const entries = (this.applicationProfile[0] as any)["@graph"];
        const languageKey = LanguageUtil.getLanguage();
        const oldColumns = this.loadFromLocalStorage();
        for (const entry of entries) {
          if (
            Object.prototype.hasOwnProperty.call(
              entry,
              "http://www.w3.org/ns/shacl#name"
            )
          ) {
            if (
              Object.prototype.hasOwnProperty.call(
                entry,
                "https://purl.org/coscine/invisible"
              ) &&
              entry["https://purl.org/coscine/invisible"][0]["@value"] === "1"
            ) {
              continue;
            }
            for (const name of entry["http://www.w3.org/ns/shacl#name"]) {
              if (name["@language"] === languageKey) {
                const identifier =
                  entry["http://www.w3.org/ns/shacl#path"][0]["@id"];
                // read the active value from the localstorage
                let activeColumn = false;
                for (const oldColumn of oldColumns) {
                  if ((oldColumn as any).key === identifier) {
                    activeColumn = (oldColumn as any).active;
                  }
                }
                tmpColumns.push({
                  label: name["@value"],
                  key: identifier,
                  sortable: true,
                  active: activeColumn,
                });
              }
            }
          }
        }
      }
      this.$set(this, "columns", tmpColumns);
    },
    async openDataSourceObject(rowData: EntryDefinition) {
      if (rowData.isFolder === true && rowData.absolutepath.endsWith("/")) {
        this.isBusy = true;

        // Empty file list, since the context changes
        // (Other workaround would be to keep the editing files open)
        this.$emit("fileListEdit", []);

        // Show location change
        window.location.hash = rowData.absolutepath;

        const response = await TreeApi.treeGetMetadataWithParameter(
          this.resourceId,
          rowData.absolutepath
        );

        const tmpFolder = [] as EntryDefinition[];
        if (rowData.name === "..") {
          this.$emit("currentFolder", this.folderPath.pop() as string);
        } else if (this.currentFolder !== "") {
          this.folderPath.push(this.currentFolder);
          this.$emit("currentFolder", rowData.absolutepath);
        } else {
          this.$emit("currentFolder", rowData.absolutepath);
        }

        if (this.folderPath.length > 0) {
          const path = this.folderPath[this.folderPath.length - 1];
          tmpFolder.push({
            isFolder: true,
            name: "..",
            absolutepath: path,
            path: path,
            showOnly: true,
          });
        }

        for (const obj of response.data.data.fileStorage) {
          const newEntry: EntryDefinition = {
            isFolder: obj.IsFolder,
            name: obj.Name,
            path: obj.Path,
            absolutepath: obj.Path,
            lastModified: obj.Modified,
            created: obj.Created,
            size: obj.Size,
          };

          const resultArray = MetadataManagerUtil.filterMetadataStorage(
            response.data.data.metadataStorage,
            newEntry.absolutepath
          );

          if (resultArray.length > 0) {
            const result = resultArray[0][Object.keys(resultArray[0])[0]];

            for (const key of Object.keys(result)) {
              (newEntry as any)[key] = result[key][0].value;
            }
          }

          tmpFolder.push(newEntry);
        }
        this.isBusy = false;
        this.$emit("folder", tmpFolder);
      } else {
        const response = await BlobApi.blobGetFileWithParameter(
          this.resourceId,
          rowData.absolutepath,
          {
            responseType: "blob",
          }
        );
        fileSaver.saveAs(response.data, rowData.name);
      }
    },
    onRowSelected(items: EntryDefinition[]) {
      this.downloadTrigger = items.length > 0;
      this.$emit("showDetail", this.downloadTrigger);
      this.selectAll = items.length === this.folder.length;
      // Filter out folders like ".."
      this.selectableFiles = items.filter((item) => !item.showOnly);
      this.updateFileListEdit();
    },
    allSelect(row: any) {
      if (this.selectAll) {
        row.selectAllRows();
      } else {
        row.clearSelected();
      }
    },
    select(row: any) {
      if (row.rowSelected) {
        (this.$refs.adaptTable as BTable).selectRow(row.index);
      } else {
        (this.$refs.adaptTable as BTable).unselectRow(row.index);
      }
    },
    clickFileSelect() {
      this.$emit("clickFileSelect");
    },
    updateFileListEdit() {
      const newFileListEdit = [] as EntryDefinition[];
      for (const currentFileEdit of this.fileListEdit) {
        const fileEdit = currentFileEdit;
        if (fileEdit.path !== this.currentFolder) {
          newFileListEdit.push(fileEdit);
        } else {
          const selectedFile = this.selectableFiles.find(
            (f) =>
              this.currentFolder === fileEdit.path && f.name === fileEdit.name
          );
          if (selectedFile) {
            newFileListEdit.push(fileEdit);
          }
        }
      }
      for (const currentSelectableFile of this.selectableFiles) {
        const selectableFile = currentSelectableFile;
        const fileEdit = newFileListEdit.find(
          (f) => f.path === this.currentFolder && f.name === selectableFile.name
        );
        if (!fileEdit) {
          MetadataManagerUtil.loadMetadata(
            (loadedMetadata: any) => {
              newFileListEdit.push({
                path: this.currentFolder,
                version: "1.0.0",
                uploading: false,
                name: selectableFile.name,
                metadata: loadedMetadata,
                isFolder: selectableFile.isFolder,
                absolutepath: selectableFile.absolutepath,
                info: selectableFile.info,
                size: selectableFile.size,
              });
            },
            selectableFile,
            this.resourceId
          );
        }
      }
      this.$emit("fileListEdit", newFileListEdit);
      if (this.selectableFiles.length > 0) {
        this.$emit("showDetail", true);
        this.$emit("fileInfo", this.selectableFiles[0]);
      } else {
        this.$emit("showDetail", false);
        this.$emit("fileInfo", {});
      }
    },
    renderDate(item: EntryDefinition) {
      if (item.lastModified === null || item.lastModified === undefined) {
        return "";
      }
      const date = item.lastModified;
      const dateObject = new Date(date);
      return dateObject.toLocaleDateString(this.$i18n.locale);
    },
    renderSize(item: EntryDefinition) {
      if (item.size === null || item.size === undefined) {
        return "";
      }
      return FileUtil.formatBytes(item.size);
    },
  },
});
</script>

<style>
.btn-link {
  padding-left: 5px !important;
  padding-right: 5px !important;
  background: none !important;
  min-width: auto;
}
#resourceViewTable thead th:first-of-type div {
  display: inline;
  position: relative;
  margin-left: 5px;
}
#resourceViewTable thead th:first-of-type div label {
  cursor: pointer;
}
#resourceViewTable thead th:last-of-type {
  text-align: center;
}
#addColumnDropDown button {
  padding: 0;
  margin: 0;
}
#addColumnDropDown,
#addColumnDropDown__BV_toggle_,
#addColumnDropDown button {
  width: 30px;
  max-width: 30px;
}
#addColumnDropDown__BV_toggle_ {
  min-width: 30px;
}
#addColumnDropDown ul {
  padding-left: 10px;
}
#resourceViewTable td,
#resourceViewTable th {
  vertical-align: middle;
  cursor: initial;
  white-space: nowrap;
}
#resourceViewTable td,
#resourceViewTable tr td:not(:first-child):not(:last-child),
#resourceViewTable tr th:not(:first-child):not(:last-child) {
  position: relative;
}
#resourceViewTable td a {
  margin-left: 10px;
  margin-right: 30px;
  vertical-align: super;
}
#resourceViewTable tr td:nth-child(2),
#resourceViewTable tr th:nth-child(2) {
  max-width: 170px !important;
  min-width: 170px !important;
  width: 170px !important;
}
#resourceViewTable tr td:last-child,
#resourceViewTable tr th:last-child {
  max-width: 55px !important;
  min-width: 55px !important;
  width: 55px !important;
}
#resourceViewTable tr td:not(:first-child):not(:last-child),
#resourceViewTable tr th:not(:first-child):not(:last-child) {
  max-width: 200px;
  text-overflow: ellipsis;
  overflow: hidden;
}
#resourceViewTable i,
#resourceViewTable input,
#resourceViewTable div.tableCheck.custom-checkbox label,
.checkFile {
  cursor: pointer;
}
#resourceViewTable tr:hover .dotMenu button {
  font-weight: bold;
  margin: 0;
}
#resourceViewTable .dotMenu {
  position: absolute;
  right: 0px;
}
#resourceViewTable .dotMenu .dropdown-item {
  margin: 1px;
}
.adaptTable {
  overflow: auto;
  position: absolute;
  top: 65px;
  bottom: 0px;
  left: 10px;
  right: 10px;
  width: auto;
}
#resourceViewTable {
  overflow: visible;
}
</style>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
#resourceViewTable th:last-of-type,
.center-align {
  text-align: center;
}
#resourceViewTable th > i {
  position: absolute;
  right: 10px;
  top: 8px;
}
#resourceViewTable th .additionalColumnHeader {
  margin-right: 20px;
}
.rightFloating {
  float: right;
}
.dataSourceItem {
  vertical-align: sub;
}
.DataSource {
  height: inherit;
  margin-top: 7px;
}
.tableCheck {
  text-align: center;
  margin-right: -0.5em;
  position: absolute;
  top: 15px;
  left: 17px;
  cursor: pointer;
}
.headerRow {
  margin-bottom: -0.95em;
}
#resourceViewTable .tableCheck,
#resourceViewTable .dotMenu {
  visibility: hidden;
}
#resourceViewTable tr:hover .tableCheck,
#resourceViewTable tr:hover .dotMenu,
#resourceViewTable .b-table-row-selected .tableCheck {
  visibility: visible;
}
.leftButton {
  height: calc(1.4em + 0.75rem + 2px);
}
.headerLeftCol {
  padding-right: 0;
  padding-left: 10px;
}
.headerRightCol {
  padding-left: 0;
  padding-right: 10px;
}
#filterInput {
  max-height: 30px;
}
#addColumnDropDown .custom-control {
  margin-right: 10px;
}
</style>
